SystemOrganization addCategory: #WeightLiftLog!
SystemOrganization addCategory: 'WeightLiftLog-Core'!
SystemOrganization addCategory: 'WeightLiftLog-JavascriptLibraries'!
SystemOrganization addCategory: 'WeightLiftLog-REST'!
SystemOrganization addCategory: 'WeightLiftLog-Test'!
SystemOrganization addCategory: 'WeightLiftLog-Transformers'!
SystemOrganization addCategory: 'WeightLiftLog-View'!

!OrderedDictionary methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 10/25/2016 18:19'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value | result at: key put: (aBlock value: value) ].
	^ result! !

!String methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/18/2016 23:32'!
asWLDuration
	"convert from [nnnd]hh:mm:ss[.nanos] format. [] implies optional elements"

	^ Duration fromWLString: self! !

WAFileLibrary subclass: #JQTouchPunchDeploymentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-JavascriptLibraries'!

!JQTouchPunchDeploymentLibrary methodsFor: 'accessing' stamp: 'MarkNelson 8/15/2016 21:52'!
selectorsToInclude
	^ #(#touchPunchJs)! !

!JQTouchPunchDeploymentLibrary methodsFor: 'uploaded' stamp: 'MarkNelson 8/15/2016 21:52'!
touchPunchJs
	^ '/*!!
 * jQuery UI Touch Punch 0.2.3
 *
 * Copyright 2011–2014, Dave Furfero
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 * Depends:
 *  jquery.ui.widget.js
 *  jquery.ui.mouse.js
 */
!!function(a){function f(a,b){if(!!(a.originalEvent.touches.length>1)){a.preventDefault();var c=a.originalEvent.changedTouches[0],d=document.createEvent("MouseEvents");d.initMouseEvent(b,!!0,!!0,window,1,c.screenX,c.screenY,c.clientX,c.clientY,!!1,!!1,!!1,!!1,0,null),a.target.dispatchEvent(d)}}if(a.support.touch="ontouchend"in document,a.support.touch){var e,b=a.ui.mouse.prototype,c=b._mouseInit,d=b._mouseDestroy;b._touchStart=function(a){var b=this;!!e&&b._mouseCapture(a.originalEvent.changedTouches[0])&&(e=!!0,b._touchMoved=!!1,f(a,"mouseover"),f(a,"mousemove"),f(a,"mousedown"))},b._touchMove=function(a){e&&(this._touchMoved=!!0,f(a,"mousemove"))},b._touchEnd=function(a){e&&(f(a,"mouseup"),f(a,"mouseout"),this._touchMoved||f(a,"click"),e=!!1)},b._mouseInit=function(){var b=this;b.element.bind({touchstart:a.proxy(b,"_touchStart"),touchmove:a.proxy(b,"_touchMove"),touchend:a.proxy(b,"_touchEnd")}),c.call(b)},b._mouseDestroy=function(){var b=this;b.element.unbind({touchstart:a.proxy(b,"_touchStart"),touchmove:a.proxy(b,"_touchMove"),touchend:a.proxy(b,"_touchEnd")}),d.call(b)}}}(jQuery);'! !

WAFileLibrary subclass: #JQTouchPunchDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-JavascriptLibraries'!

!JQTouchPunchDevelopmentLibrary methodsFor: 'accessing' stamp: 'MarkNelson 8/15/2016 21:48'!
selectorsToInclude
	^ #(#touchPunchJs)! !

!JQTouchPunchDevelopmentLibrary methodsFor: 'uploaded' stamp: 'MarkNelson 8/15/2016 21:48'!
touchPunchJs
	^ '/*!!
 * jQuery UI Touch Punch 0.2.3
 *
 * Copyright 2011–2014, Dave Furfero
 * Dual licensed under the MIT or GPL Version 2 licenses.
 *
 * Depends:
 *  jquery.ui.widget.js
 *  jquery.ui.mouse.js
 */
(function ($) {

  // Detect touch support
  $.support.touch = "ontouchend" in document;

  // Ignore browsers without touch support
  if (!!$.support.touch) {
    return;
  }

  var mouseProto = $.ui.mouse.prototype,
      _mouseInit = mouseProto._mouseInit,
      _mouseDestroy = mouseProto._mouseDestroy,
      touchHandled;

  /**
   * Simulate a mouse event based on a corresponding touch event
   * @param {Object} event A touch event
   * @param {String} simulatedType The corresponding mouse event
   */
  function simulateMouseEvent (event, simulatedType) {

    // Ignore multi-touch events
    if (event.originalEvent.touches.length > 1) {
      return;
    }

    event.preventDefault();

    var touch = event.originalEvent.changedTouches[0],
        simulatedEvent = document.createEvent("MouseEvents");
    
    // Initialize the simulated mouse event using the touch event"s coordinates
    simulatedEvent.initMouseEvent(
      simulatedType,    // type
      true,             // bubbles                    
      true,             // cancelable                 
      window,           // view                       
      1,                // detail                     
      touch.screenX,    // screenX                    
      touch.screenY,    // screenY                    
      touch.clientX,    // clientX                    
      touch.clientY,    // clientY                    
      false,            // ctrlKey                    
      false,            // altKey                     
      false,            // shiftKey                   
      false,            // metaKey                    
      0,                // button                     
      null              // relatedTarget              
    );

    // Dispatch the simulated event to the target element
    event.target.dispatchEvent(simulatedEvent);
  }

  /**
   * Handle the jQuery UI widget"s touchstart events
   * @param {Object} event The widget element"s touchstart event
   */
  mouseProto._touchStart = function (event) {

    var self = this;

    // Ignore the event if another widget is already being handled
    if (touchHandled || !!self._mouseCapture(event.originalEvent.changedTouches[0])) {
      return;
    }

    // Set the flag to prevent other widgets from inheriting the touch event
    touchHandled = true;

    // Track movement to determine if interaction was a click
    self._touchMoved = false;

    // Simulate the mouseover event
    simulateMouseEvent(event, "mouseover");

    // Simulate the mousemove event
    simulateMouseEvent(event, "mousemove");

    // Simulate the mousedown event
    simulateMouseEvent(event, "mousedown");
  };

  /**
   * Handle the jQuery UI widget"s touchmove events
   * @param {Object} event The document"s touchmove event
   */
  mouseProto._touchMove = function (event) {

    // Ignore event if not handled
    if (!!touchHandled) {
      return;
    }

    // Interaction was not a click
    this._touchMoved = true;

    // Simulate the mousemove event
    simulateMouseEvent(event, "mousemove");
  };

  /**
   * Handle the jQuery UI widget"s touchend events
   * @param {Object} event The document"s touchend event
   */
  mouseProto._touchEnd = function (event) {

    // Ignore event if not handled
    if (!!touchHandled) {
      return;
    }

    // Simulate the mouseup event
    simulateMouseEvent(event, "mouseup");

    // Simulate the mouseout event
    simulateMouseEvent(event, "mouseout");

    // If the touch interaction did not move, it should trigger a click
    if (!!this._touchMoved) {

      // Simulate the click event
      simulateMouseEvent(event, "click");
    }

    // Unset the flag to allow other widgets to inherit the touch event
    touchHandled = false;
  };

  /**
   * A duck punch of the $.ui.mouse _mouseInit method to support touch events.
   * This method extends the widget with bound touch event handlers that
   * translate touch events to mouse events and pass them to the widget"s
   * original mouse event handling methods.
   */
  mouseProto._mouseInit = function () {
    
    var self = this;

    // Delegate the touch handlers to the widget"s element
    self.element.bind({
      touchstart: $.proxy(self, "_touchStart"),
      touchmove: $.proxy(self, "_touchMove"),
      touchend: $.proxy(self, "_touchEnd")
    });

    // Call the original $.ui.mouse init method
    _mouseInit.call(self);
  };

  /**
   * Remove the touch event handlers
   */
  mouseProto._mouseDestroy = function () {
    
    var self = this;

    // Delegate the touch handlers to the widget"s element
    self.element.unbind({
      touchstart: $.proxy(self, "_touchStart"),
      touchmove: $.proxy(self, "_touchMove"),
      touchend: $.proxy(self, "_touchEnd")
    });

    // Call the original $.ui.mouse destroy method
    _mouseDestroy.call(self);
  };

})(jQuery);'! !

WAFileLibrary subclass: #WLStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLStyle methodsFor: 'stylesheets' stamp: 'MarkNelson 5/4/2016 22:14'!
addLiftCss
	^ '
	body { 
	background: #ddd;
	 }
'! !

!WLStyle methodsFor: 'stylesheets' stamp: 'MarkNelson 8/21/2016 08:35'!
chartCss
	^ '
.legend {
margin-top: 1em;
}'! !

!WLStyle methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:49'!
editSessionsCss
	^ '
	td:first-child div { 
 }
'! !

!WLStyle methodsFor: 'stylesheets' stamp: 'MarkNelson 8/11/2016 00:28'!
mainCss
	^ '
	body { 
	background: #eee;
	 }
	
	td, tr,th {
border: 1px solid black;
}

td:first-child { 

 }

tr:nth-child(odd){
background: #aaa;
}

input:focus{
background: #cff;
}

input.checkbox{
display: inline;
}

.panel-heading a {
color: white;
}

.navbar-link.navbar-right { 
margin-right: 0px;
 }
'! !

!WASelectTag methodsFor: '*WeightLiftLog-View' stamp: 'MarkNelson 7/2/2016 23:31'!
tbsFormControl
	self class: 'form-control'! !

WATask subclass: #WLLoginTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLLoginTask methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:50'!
go
	| loginView group groupView |
	loginView := WLLoginView new.
	group := self call: loginView.
	self session group: group.
	groupView := WLGroupView with: group.
	self call: groupView.
	self session unregister.
	self requestContext redirectTo: self application url! !

WATask subclass: #WLStartNewWorkoutSessionTask
	instanceVariableNames: 'possiblePeople possibleExercises header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLStartNewWorkoutSessionTask class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:06'!
withLifts: liftNames andPeople: aWLPersonCollection
	^ self new
		possibleExercises: liftNames;
		possiblePeople: aWLPersonCollection;
		yourself! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 22:49'!
getNewSessionsForExercise: aWLExercise andPeople: aWLPersonCollection
	^ self getNewSessionsForExercise: aWLExercise andPeople: aWLPersonCollection onDate: Date today! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:13'!
getNewSessionsForExercise: aWLExercise andPeople: aWLPersonCollection onDate: aDate
	| newSessions |
	newSessions := aWLPersonCollection collect: [ :person | person getSessionForExercise: aWLExercise onDate: aDate ].
	^ newSessions! !

!WLStartNewWorkoutSessionTask methodsFor: 'running' stamp: 'MarkNelson 10/13/2016 18:11'!
getOrderedExercises: aWLExerciseCollection
	| orderedExercises |
	aWLExerciseCollection size > 1
		ifTrue: [ orderedExercises := self call: (WLWorkoutOrderingComponent withItems: aWLExerciseCollection) ]
		ifFalse: [ orderedExercises := aWLExerciseCollection ].
	orderedExercises ifNil: [ self answer ].
	^ orderedExercises! !

!WLStartNewWorkoutSessionTask methodsFor: 'running' stamp: 'MarkNelson 10/13/2016 18:10'!
getOrderedPeople: aWLPersonCollection
	| orderedPeople |
	aWLPersonCollection size > 1
		ifTrue: [ orderedPeople := self call: (WLWorkoutOrderingComponent withItems: aWLPersonCollection) ]
		ifFalse: [ orderedPeople := aWLPersonCollection ].
	orderedPeople ifNil: [ self answer ].
	^ orderedPeople! !

!WLStartNewWorkoutSessionTask methodsFor: 'running' stamp: 'MarkNelson 7/10/2016 17:24'!
go
	| selected selectionComponent |
	selectionComponent := WLWorkoutSelectionComponent withExercises: possibleExercises andPeople: possiblePeople.
	selected := self call: selectionComponent.
	selected ifNil: [ self answer: nil ] ifNotNil: [ self startSessionWithSelected: selected ]! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:05'!
header
	^ header! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:05'!
header: anObject
	header := anObject! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:07'!
possibleExercises: aWLExerciseCollection
	possibleExercises := aWLExerciseCollection! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:29'!
possiblePeople
	^ possiblePeople! !

!WLStartNewWorkoutSessionTask methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:29'!
possiblePeople: anObject
	possiblePeople := anObject! !

!WLStartNewWorkoutSessionTask methodsFor: 'running' stamp: 'MarkNelson 8/14/2016 18:39'!
startSessionWithPeople: aWLPersonList andExercises: aWLExerciseList onDate: aDate
	| newSessions |
	newSessions := aWLExerciseList
		flatCollect: [ :liftName | self getNewSessionsForExercise: liftName andPeople: aWLPersonList onDate: aDate ].
	self call: (WLEditSessionsView new sessions: newSessions) onAnswer: [ self answer ]! !

!WLStartNewWorkoutSessionTask methodsFor: 'running' stamp: 'MarkNelson 10/13/2016 18:17'!
startSessionWithSelected: selected
	| selectedLifts selectedPeople aDate orderedPeople orderedExercises |
	selectedLifts := selected first.
	selectedPeople := selected second.
	aDate := selected third.
	orderedPeople := self getOrderedPeople: selectedPeople.
	orderedExercises := self getOrderedExercises: selectedLifts.
	(orderedPeople isNil or: [ orderedExercises isNil ])
		ifTrue: [ self answer ]
		ifFalse: [ self startSessionWithPeople: orderedPeople andExercises: orderedExercises onDate: aDate ]! !

!Color methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 8/20/2016 00:46'!
javascriptOn: aStream
	aStream
		nextPut: $";
		nextPut: $#.
	aStream nextPutAll: (((self red * 255) truncated printStringBase: 16) padLeftTo: 2 with: $0).
	aStream nextPutAll: (((self green * 255) truncated printStringBase: 16) padLeftTo: 2 with: $0).
	aStream nextPutAll: (((self blue * 255) truncated printStringBase: 16) padLeftTo: 2 with: $0).
	aStream nextPut: $"! !

WARestfulHandler subclass: #WLBackupsHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-REST'!

!WLBackupsHandler commentStamp: 'MarkNelson 8/21/2016 10:44' prior: 0!
I am responsible for serving backup files from the disk to the user.

!

!WLBackupsHandler class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 11:12'!
initialize
	"self initialize"

	| app |
	app := WAAdmin register: self at: 'wl-api'.
	(WAAdmin defaultDispatcher handlerAt: 'wl-api') exceptionHandler: WADebugErrorHandler! !

!WLBackupsHandler methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 11:25'!
download: aFileName
	<get>
	<path: '/download/{aFileName}'>
	| backupFiles |
	backupFiles := self findBackupFiles.
	backupFiles
		detect: [ :each | each basename = aFileName ]
		ifFound: [ :targetFile | ^ targetFile contents ]
		ifNone: [ self requestContext respond: [ :response | response notFound ] ]! !

!WLBackupsHandler methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 18:21'!
export: aGroupName
	<get>
	<path: '/export/{aGroupName}'>
	| group |
	group := WLGroup findNamed: aGroupName.
	group
		ifNotNil: [ self requestContext respond: [ :response | STON put: group onStream: response stream ] ]
		ifNil: [ self requestContext respond: [ :response | response notFound ] ]! !

!WLBackupsHandler methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 10:54'!
findBackupFiles
	^ './wl-backups' asFileReference allChildrenMatching: '*.ston'! !

!WLBackupsHandler methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 10:48'!
list
	<get>
	| backupFiles |
	backupFiles := self findBackupFiles.
	^ String
		streamContents: [ :stream | 
			backupFiles
				do: [ :each | 
					stream
						nextPutAll: each fullName;
						crlf ] ]! !

!UndefinedObject methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/18/2016 23:38'!
asWLDurationString
^ ''! !

WAComponent subclass: #WLApplicationRootComponent
	instanceVariableNames: 'main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/1/2016 21:49'!
canBeRoot
	^ true! !

!WLApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 08:46'!
deploymentInitialize
	"self deploymentInitialize"

	| app |
	app := WAAdmin register: self asApplicationAt: 'wl'.
	app
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQTouchPunchDeploymentLibrary;
		addLibrary: RickshawFileLibrary;
		addLibrary: TBSDeploymentLibrary.
	app preferenceAt: #sessionClass put: WLSeasideSession.
	app cache expiryPolicy configuration at: #cacheTimeout put: 2 hours asSeconds.
	(WAAdmin defaultDispatcher handlerAt: 'wl') exceptionHandler: WAHtmlErrorHandler! !

!WLApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 08:42'!
initialize
	"self initialize"

	| app |
	app := WAAdmin register: self asApplicationAt: 'wl'.
	app
		addLibrary: JQDevelopmentLibrary;
		addLibrary: JQUiDevelopmentLibrary;
		addLibrary: JQTouchPunchDevelopmentLibrary;
		addLibrary: RickshawFileLibrary;
		addLibrary: TBSDevelopmentLibrary.
	app preferenceAt: #sessionClass put: WLSeasideSession.
	app cache expiryPolicy configuration at: #cacheTimeout put: 2 hours asSeconds.
	(WAAdmin defaultDispatcher handlerAt: 'wl') exceptionHandler: WADebugErrorHandler! !

!WLApplicationRootComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/12/2016 00:48'!
prepareForDeploy
	"seaside deployment configuration"

	"self prepareForDeploy"

	WAAdmin clearAll.
	WAAdmin applicationDefaults removeParent: WADevelopmentConfiguration instance.
	WAFileHandler default: WAFileHandler new.
	WAFileHandler default preferenceAt: #fileHandlerListingClass put: WAHtmlFileHandlerListing.
	WAAdmin defaultDispatcher register: WAFileHandler default at: 'files'.
	WADispatcher default defaultName: 'wl'.
	ZnZincServerAdaptor startOn: 8080.
	WLApplicationRootComponent deploymentInitialize! !

!WLApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:11'!
children
	^ {main}! !

!WLApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:12'!
initialize
	super initialize.
	main := WLLoginTask new! !

!WLApplicationRootComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:09'!
main
	^ main! !

!WLApplicationRootComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:09'!
main: anObject
	main := anObject! !

!WLApplicationRootComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/6/2016 16:42'!
updateRoot: htmlRoot
	super updateRoot: htmlRoot.
	htmlRoot stylesheet url: (WLStyle urlOf: #mainCss).
	htmlRoot title: 'Avalon Weight Lift Log'.
	htmlRoot meta
		name: 'viewport';
		content: 'width=device-width, initial-scale=1.0'! !

WAComponent subclass: #WLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLComponent commentStamp: 'MarkNelson 5/11/2016 22:21' prior: 0!
Creating a base class for our components so that they can all use the same style sheet.

Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!WLComponent methodsFor: 'rendering' stamp: 'MarkNelson 5/7/2016 17:14'!
renderTodos: strings on: html
	html div
		class: 'todos';
		with: [ 
					html heading level3 with: 'TODO'.
					html unorderedList: [ strings do: [ :each | html listItem: each ] ] ]! !

WLComponent subclass: #WLEditSessionRowView
	instanceVariableNames: 'session newSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLEditSessionRowView methodsFor: 'accessing' stamp: 'MarkNelson 10/12/2016 21:38'!
exerciseName
	^ session exercise exerciseName! !

!WLEditSessionRowView methodsFor: 'initialization' stamp: 'MarkNelson 5/17/2016 21:50'!
initialize
	super initialize! !

!WLEditSessionRowView methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 12:25'!
liftingSession
	^ session! !

!WLEditSessionRowView methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 12:26'!
liftingSession: anObject
	session := anObject! !

!WLEditSessionRowView methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:57'!
newSet
	newSet ifNil: [ self resetNewSet ].
	^ newSet! !

!WLEditSessionRowView methodsFor: 'rendering' stamp: 'MarkNelson 8/18/2016 18:44'!
renderContentOn: html
	html
		tableRow: [ 
			html
				tableData: [ 
					html span with: session person name.
					self renderMinMaxTextOn: html ].
			session sets do: [ :set | html tableData: [ self renderTableDataForSet: set on: html ] ].
			html tableData: [ self renderNewSetTableDataOn: html ] ]! !

!WLEditSessionRowView methodsFor: 'rendering' stamp: 'MarkNelson 5/22/2016 23:33'!
renderMinMaxTextOn: html
	| previous |
	previous := session getPreviousSession.
	previous ifNotNil: [ html render: (WLSessionQuickView newForSession: previous) ]! !

!WLEditSessionRowView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 16:02'!
renderNewSetTableDataOn: html
	html render: (WLEditSetComponent newForSet: self newSet autofocus: true)! !

!WLEditSessionRowView methodsFor: 'rendering' stamp: 'MarkNelson 5/20/2016 00:11'!
renderTableDataForSet: aWLSet on: html
	html render: (WLEditSetComponent newForSet: aWLSet)! !

!WLEditSessionRowView methodsFor: 'private' stamp: 'MarkNelson 5/18/2016 01:08'!
resetNewSet
	newSet := session createNewSet! !

!WLEditSessionRowView methodsFor: 'actions' stamp: 'MarkNelson 5/18/2016 01:10'!
saveNewSet
	session addSet: newSet.
self resetNewSet .! !

WLComponent subclass: #WLEditSetComponent
	instanceVariableNames: 'set autofocus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

WLEditSetComponent subclass: #WLEditBodyWeightSetComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLEditBodyWeightSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:48'!
wlSetClass
	^ WLBodyWeightSet! !

!WLEditBodyWeightSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:49'!
renderContentOn: html
	self renderRepsInputGroupOn: html! !

!WLEditBodyWeightSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:56'!
renderRepsInputGroupOn: html
	html tbsInputGroup
		beSmall;
		with: [ 
					self numberInputFor: #reps on: html.
					html tbsInputGroupAddOn: 'reps' ]! !

WLEditSetComponent subclass: #WLEditLiftSetComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLEditLiftSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:05'!
wlSetClass
	^ WLLiftSet! !

!WLEditLiftSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:26'!
renderContentOn: html
	self renderWeightInputGroupOn: html.
	self renderRepsInputGroupOn: html! !

!WLEditLiftSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:42'!
renderRepsInputGroupOn: html
	html tbsInputGroup
		beSmall;
		with: [ 
					self numberInputFor: #reps on: html.
					html tbsInputGroupAddOn: 'reps' ]! !

!WLEditLiftSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:42'!
renderWeightInputGroupOn: html
	html tbsInputGroup
		beSmall;
		with: [ 
					self numberInputFor: #weight on: html.
					html tbsInputGroupAddOn: 'lbs' ]! !

!WLEditSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:10'!
newForSet: aWLSet
	^ self newForSet: aWLSet autofocus: false! !

!WLEditSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:10'!
newForSet: aWLSet autofocus: aBoolean
	| sub instance |
	sub := self subclasses detect: [ :each | each wlSetClass = aWLSet class ].
	instance := sub new
		set: aWLSet;
		autofocus: aBoolean.
	^ instance! !

!WLEditSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:04'!
wlSetClass
	^ WLSet! !

!WLEditSetComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/20/2016 00:09'!
autofocus
	^ autofocus! !

!WLEditSetComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/20/2016 07:12'!
autofocus: aBoolean
	autofocus := aBoolean! !

!WLEditSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 16:25'!
numberInputFor: aSymbol on: html
	| numberInput |
	numberInput := html numberInput tbsFormControl;
		size: 3;
		on: aSymbol of: set;
		yourself.
	autofocus
		ifTrue: [ numberInput autofocus ]
		ifFalse: [ numberInput tabIndex: 3000 ].
	^ numberInput! !

!WLEditSetComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/20/2016 00:09'!
set
	^ set! !

!WLEditSetComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/20/2016 07:11'!
set: aWLSet
	set := aWLSet! !

!WLEditSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:25'!
textInputFor: aSymbol on: html
	| textInput |
	textInput := html textInput
		tbsFormControl;
		size: 3;
		on: aSymbol of: set;
		yourself.
	autofocus
		ifTrue: [ textInput autofocus ]
		ifFalse: [ textInput tabIndex: 3000 ].
	^ textInput! !

WLEditSetComponent subclass: #WLEditTimedSetComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLEditTimedSetComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:34'!
wlSetClass
	^ WLTimedSet! !

!WLEditTimedSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/20/2016 00:28'!
renderContentOn: html
	self renderSecondsInputOn: html! !

!WLEditTimedSetComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:59'!
renderSecondsInputOn: html
	| textInput |
	html tbsInputGroup
		beSmall;
		with: [ 
					textInput := html textInput
						tbsFormControl;
						value: set seconds asWLDurationString;
						callback: [ :value | set seconds: value ];
						yourself.
					autofocus
						ifTrue: [ textInput autofocus ]
						ifFalse: [ textInput tabIndex: 3000 ].
					html tbsInputGroupAddOn: 'hhmmss' ]! !

WLComponent subclass: #WLExerciseSelectionComponent
	instanceVariableNames: 'selectedExercises exercises'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLExerciseSelectionComponent commentStamp: 'MarkNelson 8/18/2016 21:57' prior: 0!
I am responsible for displaying a list of exercises and allowing a user to select one or more of them. I will answer: a collection of the exercises selected. If none were selected, I will answer an empty collection.!

!WLExerciseSelectionComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:12'!
withExercises: aWLExerciseCollection
	^ self new
		exercises: aWLExerciseCollection;
		yourself! !

!WLExerciseSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:27'!
exercises: aWLExerciseCollection
	exercises := aWLExerciseCollection! !

!WLExerciseSelectionComponent methodsFor: 'initialization' stamp: 'MarkNelson 5/17/2016 21:27'!
initialize
	super initialize.
	selectedExercises := OrderedCollection new! !

!WLExerciseSelectionComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/11/2016 23:30'!
renderCheckBoxControlFor: aWLExercise on: html withId: anHtmlId
	html checkbox
		id: anHtmlId;
		value: (selectedExercises includes: aWLExercise);
		onTrue: [ selectedExercises add: aWLExercise ] onFalse: [ selectedExercises remove: aWLExercise ifAbsent: [ nil ] ]! !

!WLExerciseSelectionComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/3/2016 00:50'!
renderContentOn: html
	exercises do: [ :each | self renderListNameCheckBox: each on: html ]! !

!WLExerciseSelectionComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 15:48'!
renderListNameCheckBox: aWLExercise on: html
	| checkBoxId |
	html tbsInputGroup
		beLarge;
		with: [ 
					checkBoxId := html nextId.
					html tbsInputGroupAddOn: [ self renderCheckBoxControlFor: aWLExercise on: html withId: checkBoxId ].
					html label
						for: checkBoxId;
						class: 'form-control';
						with: [ html text: aWLExercise exerciseName ] ].
	html break! !

!WLExerciseSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:27'!
selectedExercises
	^ selectedExercises! !

!WLExerciseSelectionComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/10/2016 12:45'!
validate
	^ selectedExercises isEmptyOrNil not! !

WLComponent subclass: #WLPeopleSelectionComponent
	instanceVariableNames: 'people selectedPeople'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLPeopleSelectionComponent commentStamp: 'MarkNelson 8/18/2016 21:56' prior: 0!
I am responsible for displaying a list of people and allowing the user to select one or more of them. I will answer: a collection of the people selected. If no people were selected I anwer an empty collection.!

!WLPeopleSelectionComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/8/2016 22:50'!
withPeople: aWLPersonCollection
	^ self new
		people: aWLPersonCollection;
		yourself! !

!WLPeopleSelectionComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 09:38'!
withPeopleSelected: aWLPersonSubset from: aWLPersonCollection
	^ self new
		people: aWLPersonCollection;
		selectedPeople: aWLPersonSubset;
		yourself! !

!WLPeopleSelectionComponent methodsFor: 'initialization' stamp: 'MarkNelson 5/8/2016 23:14'!
initialize
	super initialize.
	selectedPeople := OrderedCollection new! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:50'!
people
	^ people! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:50'!
people: anObject
	people := anObject! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 15:52'!
renderCheckBoxControlFor: aWLPerson on: html withId: checkBoxId
	html checkbox
		id: checkBoxId;
		value: (selectedPeople includes: aWLPerson);
		onTrue: [ selectedPeople add: aWLPerson ] onFalse: [ selectedPeople remove: aWLPerson ifAbsent: [ nil ] ]! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 23:53'!
renderContentOn: html
	people do: [ :person | self renderPersonCheckBox: person on: html ]! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 15:52'!
renderPersonCheckBox: aWLPerson on: html
	| checkboxId |
	checkboxId := html nextId.
	html tbsInputGroup
		beLarge;
		with: [ 
					html tbsInputGroupAddOn: [ self renderCheckBoxControlFor: aWLPerson on: html withId: checkboxId ].
					html label
						for: checkboxId;
						class: 'form-control';
						with: [ html text: aWLPerson name ] ].
	html break! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:50'!
selectedPeople
	^ selectedPeople! !

!WLPeopleSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 09:37'!
selectedPeople: anObject
	selectedPeople := anObject! !

!WLPeopleSelectionComponent methodsFor: 'validation' stamp: 'MarkNelson 7/10/2016 17:12'!
validate
	^ selectedPeople isEmptyOrNil not! !

WLComponent subclass: #WLSessionQuickView
	instanceVariableNames: 'exerciseSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

WLSessionQuickView subclass: #WLBodyWeightSessionQuickView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLBodyWeightSessionQuickView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:51'!
wlExerciseClass
	^ WLBodyWeightExercise! !

!WLBodyWeightSessionQuickView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:53'!
renderContentOn: html
	| min max |
	html
		div: [ 
			min := exerciseSession minExerciseValue.
			max := exerciseSession maxExerciseValue.
			min ifNotNil: [ html small: 'Min: ' , min asString ].
			html break.
			max ifNotNil: [ html small: 'Max: ' , max asString ] ]! !

WLSessionQuickView subclass: #WLLiftSessionQuickView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLLiftSessionQuickView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 23:22'!
wlExerciseClass
	^ WLLiftExercise! !

!WLLiftSessionQuickView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 16:20'!
renderContentOn: html
	| min max |
	html
		div: [ 
			min := exerciseSession minExerciseValue.
			max := exerciseSession maxExerciseValue.
			min ifNotNil: [ html small: 'Min: ' , min asString ].
			html break.
			max ifNotNil: [ html small: 'Max: ' , max asString ] ]! !

!WLSessionQuickView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 23:24'!
newForSession: aWLSession
	| sub instance |
	sub := self subclasses detect: [ :each | each wlExerciseClass = aWLSession exercise class ].
	instance := sub new exerciseSession: aWLSession.
	^ instance! !

!WLSessionQuickView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 23:22'!
wlExerciseClass
	self subclassResponsibility! !

!WLSessionQuickView methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:24'!
exerciseSession
	^ exerciseSession! !

!WLSessionQuickView methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:24'!
exerciseSession: anObject
	exerciseSession := anObject! !

WLSessionQuickView subclass: #WLTimedSessionQuickView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLTimedSessionQuickView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 16:29'!
wlExerciseClass
	^ WLTimedExercise! !

!WLTimedSessionQuickView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 16:30'!
renderContentOn: html
	| min max |
	html
		div: [ 
			min := exerciseSession minExerciseValue.
			max := exerciseSession maxExerciseValue.
			min ifNotNil: [ html small: 'Min: ' , min asString ].
			html break.
			max ifNotNil: [ html small: 'Max: ' , max asString ] ]! !

WAComponent subclass: #WLHeaderComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLHeaderComponent commentStamp: 'MarkNelson 7/1/2016 21:47' prior: 0!
I am the header for the screen. I think this is where we will be putting the logout link, and any other account actions, such as changing the password.!

!WLHeaderComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:46'!
logout
	self session unregister.
	self requestContext redirectTo: self application url! !

!WLHeaderComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:42'!
navBarTitle
	^ self session isAuthenticated
		ifTrue: [ self session group groupName , ' Weight Lift Log' ]
		ifFalse: [ 'Weight Lift Log' ]! !

!WLHeaderComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 20:25'!
renderContentOn: html
	html tbsNavbar beDefault with: [ self renderNavbarContentsOn: html ]! !

!WLHeaderComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 10:28'!
renderNavbarContentsOn: html
	html tbsNavbarBrand with: self navBarTitle.
	self session isAuthenticated
		ifTrue: [ 
			html tbsButtonLink
				class: 'navbar-link navbar-right';
				callback: [ self logout ];
				with: 'Logout' ]! !

WAComponent subclass: #WLScreenComponent
	instanceVariableNames: 'header'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLScreenComponent commentStamp: 'MarkNelson 7/1/2016 21:45' prior: 0!
I'm the whole screen view component. I should be set as the main: component in WLApplicationRootComponent.

I will be responsible for displaying the header and footers in a consistent manner.!

WLScreenComponent subclass: #WLAddNewExerciseView
	instanceVariableNames: 'exerciseTypeDict exerciseName newExercise group errorMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLAddNewExerciseView class methodsFor: 'instance creation' stamp: 'MarkNelson 7/17/2016 15:09'!
forGroup: aWLGroup
	| instance |
	instance := self new.
	instance group: aWLGroup.
	^ instance! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:39'!
cancel
	self answer: nil! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:08'!
group
	^ group! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:08'!
group: aWLGroup
	group := aWLGroup! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/26/2016 07:21'!
initialize
	super initialize.	"Leaving WLRunExercise out for now because it needs more work."
	exerciseTypeDict := Dictionary
		newFrom:
			(WLExercise allSubclasses select: [ :c | (c = WLRunExercise) not ] thenCollect: [ :each | each -> each displayString ])! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:24'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: 'Add new exercise'.
			self renderErrorMessageOn: html.
			html
				form: [ 
					self renderNameInputOn: html.
					self renderExerciseTypeFieldOn: html.
					self renderSaveAndCancelOn: html ] ]! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:19'!
renderErrorMessageOn: html
	errorMessage ifNotNil: [ html tbsAlert beDanger with: [ html text: errorMessage ] ]! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 23:28'!
renderExerciseTypeFieldOn: html
	html
		tbsFormGroup: [ 
			html label: 'Exercise Type'.
			html select tbsFormControl
				callback: [ :value | newExercise := value new ];
				list: exerciseTypeDict keys;
				labels: [ :key | exerciseTypeDict at: key ] ]! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 23:24'!
renderNameInputOn: html
	html
		tbsFormGroup: [ 
			html label: 'Exercise Name'.
			html textInput autofocus tbsFormControl callback: [ :value | exerciseName := value ] ]! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:10'!
save
	newExercise exerciseName: exerciseName.
	self validate
		ifTrue: [ self answer: newExercise ]! !

!WLAddNewExerciseView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:14'!
validate
	"Make sure that the group doesn't already have an exercise with the same name"

	| valid |
	valid := (group hasExerciseNamed: exerciseName) not.
	valid
		ifFalse: [ errorMessage := 'An exercise with that name already exists' ].
	^ valid! !

WLScreenComponent subclass: #WLAddNewPersonView
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLAddNewPersonView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:34'!
initialize
"self initialize"

WAAdmin register: self asApplicationAt: 'wl/addPerson'! !

!WLAddNewPersonView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:47'!
withPerson: aWLPerson
^ self new person: aWLPerson ; yourself! !

!WLAddNewPersonView methodsFor: 'actions' stamp: 'MarkNelson 4/28/2016 22:39'!
cancel
self answer: nil! !

!WLAddNewPersonView methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:47'!
person
	^ person! !

!WLAddNewPersonView methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:47'!
person: anObject
	person := anObject! !

!WLAddNewPersonView methodsFor: 'rendering' stamp: 'MarkNelson 8/15/2016 21:24'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: 'Add new person'.
			html
				form: [ 
					self renderNameFieldOn: html.
					self renderSaveAndCancelOn: html ] ]! !

!WLAddNewPersonView methodsFor: 'rendering' stamp: 'MarkNelson 7/2/2016 23:42'!
renderNameFieldOn: html
	html
		tbsFormGroup: [ 
			html label: 'Name'.
			html textInput autofocus tbsFormControl on: #name of: person ]! !

!WLAddNewPersonView methodsFor: 'actions' stamp: 'MarkNelson 5/4/2016 22:09'!
save
	self answer: person! !

WLScreenComponent subclass: #WLAddPersonToWorkoutComponent
	instanceVariableNames: 'peopleSelector errorMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLAddPersonToWorkoutComponent commentStamp: 'MarkNelson 7/16/2016 19:27' prior: 0!
This should let you redefine the people involved in the current workout session.

Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.


    Implementation Points!

!WLAddPersonToWorkoutComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:24'!
withPeopleSelected: aWLPersonCollection from: allWLPeople
	| instance peopleSelector |
	peopleSelector := WLPeopleSelectionComponent withPeopleSelected: aWLPersonCollection from: allWLPeople.
	instance := self new.
	instance peopleSelector: peopleSelector.
	^ instance! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 21:45'!
addNewPerson
	| person component group |
	group := self session group.
	person := WLPerson new.
	component := WLAddNewPersonView withPerson: person.
	self
		call: component
		onAnswer: [ :answer | 
			answer
				ifNotNil: [ 
					group addPerson: answer.
					group save ] ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:56'!
cancel
	self answer: nil! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 09:39'!
children
	^ Array with: peopleSelector! !

!WLAddPersonToWorkoutComponent methodsFor: 'initialization' stamp: 'MarkNelson 7/17/2016 09:38'!
initialize
	super initialize.
	peopleSelector := WLPeopleSelectionComponent new! !

!WLAddPersonToWorkoutComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 09:44'!
peopleSelector
	^ peopleSelector! !

!WLAddPersonToWorkoutComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 09:44'!
peopleSelector: anObject
	peopleSelector := anObject! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 21:45'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: 'Modify people in workout'.
			self renderCreateNewPersonLinkOn: html.
			self renderErrorMessageOn: html.
			self renderSelectionFormOn: html ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 21:45'!
renderCreateNewPersonLinkOn: html
	html
		paragraph: [ 
			html anchor
				callback: [ self addNewPerson ];
				with: [ html text: 'Create new person' ] ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 11:11'!
renderErrorMessageOn: html
	errorMessage ifNotNil: [ html tbsAlert beDanger with: [ html text: errorMessage ] ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:24'!
renderSelectionFormOn: html
	html
		form: [ 
			html div: [ html render: peopleSelector ].
			self renderSaveAndCancelOn: html ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 10/13/2016 06:53'!
save
	self validate
		ifTrue: [ 
			| orderedPeople |
			orderedPeople := self call: (WLWorkoutOrderingComponent withItems: peopleSelector selectedPeople).
			self answer: orderedPeople ]! !

!WLAddPersonToWorkoutComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 11:10'!
validate
	| valid |
	valid := peopleSelector validate.
	valid
		ifFalse: [ errorMessage := 'You must select at least one person to be in a workout.' ].
	^ valid! !

WLScreenComponent subclass: #WLBackupsView
	instanceVariableNames: 'backupFiles selectedFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLBackupsView methodsFor: 'initialization' stamp: 'MarkNelson 8/21/2016 10:17'!
findBackupFiles
	^ './wl-backups' asFileReference allChildrenMatching: '*.ston'! !

!WLBackupsView methodsFor: 'initialization' stamp: 'MarkNelson 8/21/2016 10:15'!
initialize
	super initialize.
	backupFiles := self findBackupFiles! !

!WLBackupsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 11:27'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html
				tbsListGroup: [ 
					backupFiles
						do: [ :each | 
							html
								tbsListGroupItem: [ 
									html anchor
										url: '/wl-api/download/' , each basename;
										with: each fullName ] ] ].
			selectedFile ifNotNil: [ html paragraph: selectedFile contents ] ]! !

WLScreenComponent subclass: #WLEditSessionsView
	instanceVariableNames: 'sessions sessionViews activeExerciseName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 10/13/2016 18:30'!
activeExerciseName
	^ activeExerciseName ifNil: [ activeExerciseName := sessions keys first ]! !

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 5/2/2016 22:25'!
children
	^ Array
		with: self;
		withAll: sessionViews! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 18:01'!
completeSession
	self saveSessions.
	self answer: sessions! !

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 15:57'!
currentSetNumber
	^ (sessions collect: [ :each | (each value collect: [ :s | s sets size]) max] ) max! !

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 15:58'!
findSessionViewForSession: aWLSession 
^ sessionViews detect:[:view | view liftingSession = aWLSession]! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:57'!
getDateOfWorkout
	| valuesCollected |
	valuesCollected := (sessions valuesCollect: [ :oc | oc collect: [ :wlSession | wlSession date ] ]) values first first.
	^ valuesCollected! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:50'!
getExercisesInWorkout
	| valuesCollected |
	valuesCollected := (sessions valuesCollect: [ :oc | oc collect: [ :wlSession | wlSession exercise ] ]) values.
	^ valuesCollected  flatCollectAsSet: [ :x | x ]! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:23'!
getPeopleInWorkout
|valuesCollected people|
valuesCollected := (sessions valuesCollect: [ :oc| oc collect: [ :wlSession | wlSession person ] ]) values.
people := valuesCollected flatCollectAsSet: [:x | x].
^ people! !

!WLEditSessionsView methodsFor: 'initialization' stamp: 'MarkNelson 7/11/2016 23:32'!
initialize
	super initialize! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/18/2016 18:32'!
modifyPeopleInWorkout
	| peopleSelector newPersonSelection date newSessions |
	peopleSelector := WLAddPersonToWorkoutComponent
		withPeopleSelected: self getPeopleInWorkout
		from: self session group people.
	newPersonSelection := self call: peopleSelector.
	newPersonSelection
		ifNotNil: [ 
			date := self getDateOfWorkout.
			newSessions := newPersonSelection
				flatCollect: [ :person | self getExercisesInWorkout collect: [ :exercise | person getSessionForExercise: exercise onDate: date ] ].
			self sessions: newSessions asOrderedCollection ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 14:59'!
renderAddPersonToWorkoutLinkOn: html
	html tbsRow
		class: 'pull-right';
		with: [ 
					html anchor
						callback: [ self modifyPeopleInWorkout ];
						with: 'Add people' ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 15:02'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			self renderHeadingOn: html.
			self renderNavBarOn: html.
			self renderSessionFormOn: html ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 15:02'!
renderHeadingOn: html
	html heading: 'Session for ' , sessions any first date asString.
	self renderAddPersonToWorkoutLinkOn: html! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 5/21/2016 00:21'!
renderNavBarOn: html
	html div
		class: 'row';
		with: [ 
					html div
						class: 'col-sm-12';
						with: [ 
									html tbsNav
										bePills;
										with: [ 
													sessions
														keysDo: [ :exerciseName | 
															| nav |
															nav := html tbsNavItem
																class: 'active' if: exerciseName = self activeExerciseName;
																with: [ 
																			html anchor
																				callback: [ self setActiveExercise: exerciseName ];
																				with: exerciseName ];
																yourself ] ] ] ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 7/19/2016 17:52'!
renderSessionFormOn: html
	html form
		defaultAction: [ self saveSessions ];
		with: [ 
					self renderSessionTable: html.
					html break.
					html tbsButton
						class: 'btn-warning btn-sm';
						callback: [ self completeSession ];
						with: 'Complete session' ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 15:01'!
renderSessionTable: html
	| sessionCollection |
	sessionCollection := sessions at: self activeExerciseName.
	html
		div: [ 
			html heading level3 with: activeExerciseName.
			html table
				frame: #border;
				with: [ 
							self renderSessionTableHeader: html.
							sessionCollection do: [ :each | html render: (self findSessionViewForSession: each) ] ].
			html break.
			html tbsButton beLarge beDefault
				callback: [ self saveSessions ];
				with: 'Save Sets' ]! !

!WLEditSessionsView methodsFor: 'rendering' stamp: 'MarkNelson 5/2/2016 22:33'!
renderSessionTableHeader: html
	html
		tableRow: [ 
			html tableHeading: 'Person'.
			(1 to: self currentSetNumber + 1) do: [ :index | html tableHeading: 'Set ' , index asString ] ]! !

!WLEditSessionsView methodsFor: 'actions' stamp: 'MarkNelson 5/18/2016 01:21'!
saveSessions
	sessionViews
		do: [ :view | 
			view newSet isEmpty
				ifFalse: [ view saveNewSet ] ]! !

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 12:22'!
sessions
	^ sessions! !

!WLEditSessionsView methodsFor: 'accessing' stamp: 'MarkNelson 10/13/2016 18:23'!
sessions: aWLSessionCollection
	| sessionDict |
	sessionDict := OrderedDictionary new.
	aWLSessionCollection
		do: [ :s | 
			sessionDict
				at: s exerciseName
				ifPresent: [ :v | v add: s ]
				ifAbsent: [ sessionDict at: s exerciseName put: (OrderedCollection with: s) ] ].
	sessions := sessionDict.
	sessionViews := aWLSessionCollection collect: [ :s | WLEditSessionRowView new liftingSession: s ]! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/21/2016 00:05'!
setActiveExercise: anExerciseName
	activeExerciseName := anExerciseName! !

!WLEditSessionsView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 16:07'!
updateRoot: htmlRoot
	super updateRoot: htmlRoot.
	htmlRoot stylesheet url: (WLStyle urlOf: #editSessionsCss)! !

WLScreenComponent subclass: #WLGroupView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLGroupView commentStamp: 'MarkNelson 7/17/2016 15:04' prior: 0!
I am the landing page for the group. I should provide a quick way of navigating to each person and exercise type, and have a way of starting a new workout.
!

!WLGroupView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/30/2016 11:57'!
with: aWLGroup
	| instance |
	instance := self new.
	instance group: aWLGroup.
	^ instance! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 7/19/2016 18:07'!
addNewExercise
	| component |
	component := WLAddNewExerciseView forGroup: group.
	self
		call: component
		onAnswer: [ :value | 
			value
				ifNotNil: [ 
					group addExercise: value.
					group save ] ]! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 7/3/2016 00:48'!
addNewPerson
	| person component |
	person := WLPerson new.
	component := WLAddNewPersonView withPerson: person.
	self
		call: component
		onAnswer: [ :answer | 
			answer
				ifNotNil: [ 
					group addPerson: answer.
					group save ] ]! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 5/17/2016 21:08'!
getNewSessionsForLiftName: liftName
	| newSessions |
	newSessions := group people
		collect: [ :person | 
			| s |
			s := WLSession withExercise: liftName forPerson: person onDate: Date today.
			person addSession: s.
			s ].
	^ newSessions! !

!WLGroupView methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:57'!
group
	^ group! !

!WLGroupView methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 20:40'!
group: anObject
	group := anObject! !

!WLGroupView methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 20:39'!
groupName
	^ group groupName! !

!WLGroupView methodsFor: 'initialization' stamp: 'MarkNelson 7/17/2016 15:04'!
initialize
	super initialize! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 7/2/2016 20:40'!
logout
	"Testing logout by just returning control to the WLLoginTask.
Not super happy with this. How do I share the actions between the header and the main screen?"

	self answer! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 5/8/2016 23:58'!
removePerson: aWLPerson
	group removePerson: aWLPerson.
	group save! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 8/21/2016 10:28'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			self renderPeoplePanelOn: html.
			self renderLiftTypePanelOn: html.
			self renderStartNewSessionOn: html.
			self renderViewBackupsLinkOn: html.
			self renderTodos: self todoList on: html ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 5/17/2016 21:01'!
renderLiftTypePanelOn: html
	html tbsPanel bePrimary
		with: [ 
			html tbsPanelHeading: 'Lift Type'.
			html tbsPanelBody: [ self renderLiftTypes: html ].
			html
				tbsPanelFooter: [ 
					
					html anchor
						callback: [ self addNewExercise ];
						with: 'Add exercise' ] ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 5/17/2016 21:00'!
renderLiftTypes: html
	html
		tbsListGroup: [ 
			group exercises
				do: [ :each | 
					html
						tbsListGroupItem: [ 
							html anchor
								callback: [ self viewLiftGraph: each ];
								with: each exerciseName ] ] ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 5/12/2016 23:39'!
renderPeopleList: html
	html
		tbsListGroup: [ 
			group people
				do: [ :person | 
					html
						tbsListGroupItem: [ 
							html text: person name.
							html space.
							html anchor
								callback: [ self viewPerson: person ];
								with: 'View'.
							html space ] ] ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 7/2/2016 20:42'!
renderPeoplePanelOn: html
	html tbsPanel bePrimary
		with: [ 
			html tbsPanelHeading: 'People'.
			html tbsPanelBody: [ self renderPeopleList: html ].
			html
				tbsPanelFooter: [ 
					html anchor
						callback: [ self addNewPerson ];
						with: 'Add Person' ] ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 5/14/2016 08:56'!
renderStartNewSessionOn: html
	html div
		class: 'start-new';
		with: [ 
					html tbsButtonLink
						class: 'btn-primary btn-lg';
						callback: [ self startNewGroupSession ];
						with: 'Start Session' ]! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 8/21/2016 10:28'!
renderViewBackupsLinkOn: html
	html tbsButtonLink
		class: 'navbar-link navbar-right';
		callback: [ self viewBackups ];
		with: 'View Backups'! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 7/3/2016 00:48'!
startNewGroupSession
	| component |
	component := WLStartNewWorkoutSessionTask withLifts: group exercises andPeople: group people.
	self call: component onAnswer: [ group save ]! !

!WLGroupView methodsFor: 'hooks' stamp: 'MarkNelson 4/28/2016 22:56'!
states
	^ Array with: group! !

!WLGroupView methodsFor: 'rendering' stamp: 'MarkNelson 7/17/2016 15:54'!
todoList
	^ {}! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 8/21/2016 10:29'!
viewBackups
	self call: WLBackupsView new! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 5/20/2016 23:07'!
viewLiftGraph: aWLExercise
	| sessionDict graphComponent |
	sessionDict := group getSessionsByPersonFor: aWLExercise exerciseName.
	sessionDict isEmptyOrNil ifTrue: [ self inform: 'There are no sessions for this lift: ', aWLExercise exerciseName ] ifFalse:[
	graphComponent := WLSessionByPersonGraphComponent withSessions: sessionDict.
	self call: graphComponent]! !

!WLGroupView methodsFor: 'actions' stamp: 'MarkNelson 7/3/2016 00:49'!
viewPerson: aPerson
	self call: (WLPersonView newWithPerson: aPerson )! !

WLScreenComponent subclass: #WLLoginView
	instanceVariableNames: 'groupName password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/1/2016 21:54'!
cancel
	"Should we do anything on cancel? I really don't think we need to."

	! !

!WLLoginView methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:47'!
groupName
	^ groupName! !

!WLLoginView methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:47'!
groupName: anObject
	groupName := anObject! !

!WLLoginView methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:47'!
password
	^ password! !

!WLLoginView methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:47'!
password: anObject
	password := anObject! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 20:07'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			self renderMessageOn: html.
			self renderLoginFormOn: html ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:25'!
renderLoginButtonOn: html
	html div
		class: 'form-field form-submit';
		with: [ 
					html tbsSubmitButton
						bePrimary;
						callback: [ self save ];
						value: 'Login' ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:25'!
renderLoginFormOn: html
	html form
		defaultAction: [ self save ];
		with: [ 
					self renderUserNameFieldOn: html.
					self renderPasswordFieldOn: html.
					self renderLoginButtonOn: html ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 20:12'!
renderMessageOn: html
	message
		ifNotNil: [ 
			html tbsAlert beDanger
				with: [ 
					html strong: 'Login failed.'.
					html space.
					html text: message ] ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 20:09'!
renderPasswordFieldOn: html
	html
		tbsFormGroup: [ 
			html label: 'Password'.
			html passwordInput tbsFormControl
				placeholder: 'Password';
				on: #password of: self ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 20:08'!
renderUserNameFieldOn: html
	html
		tbsFormGroup: [ 
			html label: 'Group Name'.
			html textInput tbsFormControl
				placeholder: 'Name';
				on: #groupName of: self ]! !

!WLLoginView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/1/2016 22:00'!
save
	WLGroup
		find: [ :each | each groupName = groupName and: [ each password = (GRPlatform current secureHashFor: password) ] ]
		ifPresent: [ :group | self answer: group ].
	message := 'Incorrect username/password.'! !

WLScreenComponent subclass: #WLPersonView
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLPersonView class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/2/2016 23:01'!
newWithPerson: aWLPerson
	^ self new
		person: aWLPerson;
		yourself! !

!WLPersonView methodsFor: 'accessing' stamp: 'MarkNelson 5/2/2016 23:01'!
person
	^ person! !

!WLPersonView methodsFor: 'accessing' stamp: 'MarkNelson 5/2/2016 23:01'!
person: anObject
	person := anObject! !

!WLPersonView methodsFor: 'actions' stamp: 'MarkNelson 5/4/2016 22:02'!
removeSession: aWLSession 
person removeSession: aWLSession! !

!WLPersonView methodsFor: 'rendering' stamp: 'MarkNelson 7/19/2016 17:47'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: person name.
			self renderSessionListOn: html.
			self renderBackButtonOn: html ]! !

!WLPersonView methodsFor: 'rendering' stamp: 'MarkNelson 7/19/2016 20:57'!
renderSessionListItem: session on: html
	html span
		class: 'date';
		with: session date.
	html space.
	html span
		class: 'set-count';
		with: session sets size asString , ' sets'.
	html space.
	html span
		class: 'weight-spread';
		with: session minExerciseValue asString , ' - ' , session maxExerciseValue asString.
	html space.
	^ html anchor
		callback: [ self viewSession: session ];
		class: 'view-session-link';
		with: 'View'! !

!WLPersonView methodsFor: 'rendering' stamp: 'MarkNelson 7/2/2016 22:59'!
renderSessionListOn: html
	html div
		class: 'person-lift-list';
		with: [ 
					person sessionsByLiftName
						keysAndValuesDo: [ :liftName :sessions | 
							html tbsPanel bePrimary
								class: 'person-lift-section-header';
								with: [ 
											html
												tbsPanelHeading: [ 
													html anchor
														callback: [ self viewLiftNamed: liftName ];
														with: liftName ].
											html tbsListGroup
												class: 'person-lift-section';
												with: [ 
															sessions
																do: [ :session | 
																	html tbsListGroupItem
																		class: 'session-list-item';
																		with: [ self renderSessionListItem: session on: html ] ] ] ] ] ]! !

!WLPersonView methodsFor: 'rendering' stamp: 'MarkNelson 5/22/2016 22:48'!
updateRoot: htmlRoot
	super updateRoot: htmlRoot.
	htmlRoot title: 'Log for ' , person name! !

!WLPersonView methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/2/2016 23:11'!
viewLiftNamed: aString 
|targetSessions|
	targetSessions := Dictionary with: person -> (person getAllSessionsForExercise: aString).

	self call: (	WLSessionByPersonGraphComponent withSessions: targetSessions)! !

!WLPersonView methodsFor: 'actions' stamp: 'MarkNelson 7/19/2016 18:05'!
viewSession: session
	self call: (WLEditSessionsView new sessions: {session}).
	person group
		removeEmptySessions;
		save! !

!WLScreenComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/1/2016 21:46'!
children
	^ {header}! !

!WLScreenComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 23:14'!
header
	^ header! !

!WLScreenComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 23:14'!
header: anObject
	header := anObject! !

!WLScreenComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/1/2016 21:46'!
initialize
	super initialize.
	header := WLHeaderComponent new! !

!WLScreenComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/11/2016 23:41'!
renderBackButtonOn: html
	html div
		class: 'go-back';
		with: [ 
					html
						paragraph: [ 
							html anchor
								callback: [ self answer: nil ];
								with: 'Go back' ] ]! !

!WLScreenComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:01'!
renderContentOn: html
	html render: header! !

!WLScreenComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:24'!
renderSaveAndCancelOn: html
	html div
		class: 'form-field form-submit';
		with: [ 
					html tbsSubmitButton beLarge beSuccess on: #save of: self.
					html space.
					html tbsSubmitButton beWarning beLarge on: #cancel of: self ]! !

!WLScreenComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 15:59'!
renderTodos: strings on: html
	strings isEmptyOrNil
		ifFalse: [ 
			html div
				class: 'todos';
				with: [ 
							html heading level3 with: 'TODO'.
							html unorderedList: [ strings do: [ :each | html listItem: each ] ] ] ]! !

WLScreenComponent subclass: #WLSessionByPersonGraphComponent
	instanceVariableNames: 'sessionsByPersonDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLSessionByPersonGraphComponent class methodsFor: 'instance-creation' stamp: 'MarkNelson 5/9/2016 22:51'!
withSessions: aDictionary 
|instance|
instance := self new sessionsByPersonDict: aDictionary; yourself.
^ instance! !

!WLSessionByPersonGraphComponent methodsFor: 'initialization' stamp: 'MarkNelson 7/11/2016 23:37'!
initialize
	super initialize! !

!WLSessionByPersonGraphComponent methodsFor: 'rendering' stamp: 'MarkNelson 8/21/2016 09:18'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: sessionsByPersonDict any first exerciseName.
			self renderRickshawGraphOn: html.
			self renderBackButtonOn: html ]! !

!WLSessionByPersonGraphComponent methodsFor: 'rendering' stamp: 'MarkNelson 8/21/2016 09:03'!
renderRickshawGraphOn: html
	| personSeriesDict graph legend toggle highlight xAxis yAxis hover |
	personSeriesDict := sessionsByPersonDict
		collect: [ :sessions | (sessions collect: [ :session | session date asSeconds @ session maxExerciseValue ]) sort: [ :a :b | a x < b x ] ].
	html div
		class: 'chart';
		id: html nextId.
	graph := Rickshaw graph element: html lastId.
	graph beLine.
	graph height: 600.
	graph width: 1024.
	personSeriesDict keysDo: [ :person | graph addSeriesNamed: person name elements: (personSeriesDict at: person) ].
	graph optionAt: 'interpolation' put: 'linear'.
	html div
		class: 'legend';
		id: html nextId.	"The legend object is bound to a DOM element"
	legend := graph legend element: html lastId.
	toggle := legend toggle: graph.
	highlight := legend highlight: graph.
	xAxis := Rickshaw timeAxis: graph.
	yAxis := graph yAxis.
	hover := graph hover.
	html document addLoadScript: graph , legend , toggle , highlight , xAxis , yAxis , hover! !

!WLSessionByPersonGraphComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/9/2016 22:50'!
sessionsByPersonDict
	^ sessionsByPersonDict! !

!WLSessionByPersonGraphComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/9/2016 22:50'!
sessionsByPersonDict: anObject
	sessionsByPersonDict := anObject! !

!WLSessionByPersonGraphComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 08:42'!
updateRoot: htmlRoot
	super updateRoot: htmlRoot.
	htmlRoot stylesheet url: (WLStyle urlOf: #chartCss)! !

WLScreenComponent subclass: #WLWorkoutOrderingComponent
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLWorkoutOrderingComponent commentStamp: 'MarkNelson 10/13/2016 06:50' prior: 0!
I present a list of items to be ordered. !

!WLWorkoutOrderingComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 10/13/2016 06:54'!
withItems: aCollection
	^ self new
		items: aCollection;
		yourself! !

!WLWorkoutOrderingComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 21:33'!
cancel
self answer: nil! !

!WLWorkoutOrderingComponent methodsFor: 'accessing' stamp: 'MarkNelson 10/13/2016 06:52'!
items
	^ items! !

!WLWorkoutOrderingComponent methodsFor: 'accessing' stamp: 'MarkNelson 10/13/2016 06:52'!
items: aCollection
	items := aCollection! !

!WLWorkoutOrderingComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/15/2016 22:33'!
renderContentOn: html
	super renderContentOn: html.
	html
		form: [ 
			html tbsContainer
				with: [ 
					html
						tbsRow: [ 
							html tbsColumn
								smallOffset: 2;
								extraSmallSize: 8;
								with: [ self renderSortableListOn: html ] ].
					html
						tbsRow: [ 
							html tbsColumn
								smallOffset: 2;
								extraSmallSize: 8;
								with: [ self renderSaveAndCancelOn: html ] ] ] ]! !

!WLWorkoutOrderingComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 10/13/2016 18:05'!
renderSortableListOn: html
	html tbsListGroup
		script:
				(html jQuery new sortable
						onStop: (html jQuery ajax callback: [ :values | items := values ] passengers: (html jQuery this find: 'li')));
		with: [ 
					items
						do: [ :item | 
							html tbsListGroupItem
								class: 'ui-corner-all';
								passenger: item;
								with: item name ] ]! !

!WLWorkoutOrderingComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 10/13/2016 06:52'!
save
self answer: items! !

WLScreenComponent subclass: #WLWorkoutSelectionComponent
	instanceVariableNames: 'peopleSelection exerciseSelection sessionDate errorMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLWorkoutSelectionComponent class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:25'!
withExercises: aWLExerciseCollection andPeople: aWLPersonCollection
	^ self new
		exerciseSelection: (WLExerciseSelectionComponent withExercises: aWLExerciseCollection);
		peopleSelection: (WLPeopleSelectionComponent withPeople: aWLPersonCollection);
		yourself! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:57'!
cancel
	self answer: nil! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/2/2016 23:58'!
children
	^ {peopleSelection.
	exerciseSelection}! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:25'!
exerciseSelection
	^ exerciseSelection! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:25'!
exerciseSelection: aWLExerciseSelectionComponent
	exerciseSelection := aWLExerciseSelectionComponent! !

!WLWorkoutSelectionComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:51'!
initialize
	super initialize.
	sessionDate := Date today! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:53'!
peopleSelection
	^ peopleSelection! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 22:53'!
peopleSelection: anObject
	peopleSelection := anObject! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 15:55'!
renderContentOn: html
	super renderContentOn: html.
	html
		tbsContainer: [ 
			html heading: 'Setup workout'.
			html div
				class: 'container';
				with: [ 
							self renderErrorMessageOn: html.
							self renderSelectionFormOn: html ] ]! !

!WLWorkoutSelectionComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:52'!
renderDateSelectionOn: html
	html tbsRow
		with: [ 
			html tbsColumn
				mediumSize: 12;
				with: [ html dateInput on: #sessionDate of: self ] ]! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/10/2016 17:21'!
renderErrorMessageOn: html
	errorMessage ifNotNil: [ html tbsAlert beDanger with: [ html text: errorMessage ] ]! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 8/15/2016 21:24'!
renderSelectionFormOn: html
	html
		form: [ 
			self renderDateSelectionOn: html.
			html
				div: [ 
					html heading level3 with: 'Lifts'.
					html render: exerciseSelection ].
			html
				div: [ 
					html heading level3 with: 'People'.
					html render: peopleSelection ].
			self renderSaveAndCancelOn: html ]! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/10/2016 12:43'!
save
	self validate
		ifTrue: [ 
			self
				answer:
					{(exerciseSelection selectedExercises).
					(peopleSelection selectedPeople).
					sessionDate} ]! !

!WLWorkoutSelectionComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:52'!
sessionDate
	^ sessionDate! !

!WLWorkoutSelectionComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:52'!
sessionDate: aDate
	sessionDate := aDate! !

!WLWorkoutSelectionComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/10/2016 17:17'!
validate
	| valid |
	valid := exerciseSelection validate and: [ peopleSelection validate ].
	valid
		ifFalse: [ errorMessage := 'Please select at least one exercise and one person.' ]
		ifTrue: [ errorMessage := nil ].
	^ valid! !

WAComponent subclass: #WLTemplateComponent
	instanceVariableNames: 'header content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLTemplateComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:32'!
children
	^ {header.
	content}! !

!WLTemplateComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:14'!
content
	^ content! !

!WLTemplateComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:14'!
content: anObject
	content := anObject! !

!WLTemplateComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:35'!
groupName
^	'Avalon'! !

!WLTemplateComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:14'!
header
	^ header! !

!WLTemplateComponent methodsFor: 'accessing' stamp: 'MarkNelson 7/3/2016 00:14'!
header: anObject
	header := anObject! !

!WLTemplateComponent methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:18'!
logout
	^ self answer! !

!WLTemplateComponent methodsFor: 'rendering' stamp: 'MarkNelson 7/3/2016 00:15'!
renderContentOn: html
	html render: header.
	html tbsContainer: [ html render: content ]! !

SDActiveRecord subclass: #WLGroup
	instanceVariableNames: 'groupName people exercises password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLGroup class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/30/2016 22:51'!
backupTo: aFileName
	| dir archive |
	dir := WLGroup store dirForClass: WLGroup.
	dir entries select: [ :each | (each asFileReference allChildrenMatching: '*.obj') isNotEmpty ].
	archive := ZipArchive new.
	archive
		addTree: dir fullName
		removingFirstCharacters: FileSystem workingDirectory fullName size
		match: [ :each | (each asFileReference allChildrenMatching: '*.obj') isNotEmpty ].
	archive writeToFileNamed: aFileName! !

!WLGroup class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 07:09'!
findNamed: aString 
^ self find: [ :each | each groupName = aString ]! !

!WLGroup class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/30/2016 22:55'!
makeBackup
	"self makeBackup"

	self backupTo: FileSystem workingDirectory / ('WLGroup-Backup-' , Date today yyyymmdd , '.zip')! !

!WLGroup class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 8/21/2016 10:22'!
makeStonBackup
	"self makeStonBackup"

	| fileReference backupDir |
	backupDir := FileSystem workingDirectory / 'wl-backups/'.
	backupDir ensureCreateDirectory.
	fileReference := backupDir / ('WLGroup-Backup-' , Date today yyyymmdd , '.ston').
	fileReference writeStreamDo: [ :stream | WLGroup findAll do: [ :group | STON put: group onStream: stream ] ]! !

!WLGroup class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:02'!
named: aString
^ self new groupName: aString; yourself! !

!WLGroup methodsFor: 'adding' stamp: 'MarkNelson 5/15/2016 21:04'!
addExercise: aWLExercise
	self exercises add: aWLExercise! !

!WLGroup methodsFor: 'adding' stamp: 'MarkNelson 5/17/2016 20:55'!
addPerson: aWLPerson
	aWLPerson group: self.
	people add: aWLPerson! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 21:05'!
exercises
	^ exercises ifNil: [ exercises := OrderedCollection new ]! !

!WLGroup methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:45'!
getAllSessions
^people flatCollect:[:each | each getAllSessions ]! !

!WLGroup methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:30'!
getAllSessionsForExerciseNamed: aString
	^ people flatCollect: [ :person | person getAllSessionsForExercise: aString ]! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 22:46'!
getSessionsByPersonFor: aLiftName
	| assocs dict |
	assocs := people
		collect: [ :person | person -> (person getAllSessionsForExercise: aLiftName) ]
		thenSelect: [ :assoc | assoc value isEmpty not ].
	dict := Dictionary new.
	assocs do: [ :assoc | dict at: assoc key put: assoc value ].
	^ dict! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:02'!
groupName
	^ groupName! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:02'!
groupName: anObject
	groupName := anObject! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 15:13'!
hasExerciseNamed: aString
	^ self exercises anySatisfy: [ :each | each isNamed: aString ]! !

!WLGroup methodsFor: 'initialization' stamp: 'MarkNelson 5/22/2016 22:57'!
initialize
	super initialize.
	people := OrderedCollection new.
	exercises := OrderedCollection new! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:58'!
password
	^ password! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 5/30/2016 11:59'!
password: aString
	password := GRPlatform current secureHashFor: aString! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:02'!
people
	^ people! !

!WLGroup methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:02'!
people: anObject
	people := anObject! !

!WLGroup methodsFor: 'printing' stamp: 'MarkNelson 4/28/2016 23:07'!
printOn: aStream
super printOn: aStream.
aStream nextPutAll: ' - '; nextPutAll: groupName! !

!WLGroup methodsFor: 'removing' stamp: 'MarkNelson 5/8/2016 21:41'!
removeEmptySessions
	self people do: [ :person | person removeEmptySessions ]! !

!WLGroup methodsFor: 'removing' stamp: 'MarkNelson 5/22/2016 22:43'!
removePerson: aWLPerson
	people remove: aWLPerson! !

!WLGroup methodsFor: 'actions' stamp: 'MarkNelson 5/19/2016 23:13'!
save
	self removeEmptySessions.
	super save! !

!Number methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/18/2016 23:21'!
asWLDuration
	^ Duration seconds: self asInteger! !

TestCase subclass: #WLDurationExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLDurationExtensionTests methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:32'!
testDefaultParsing
	| targetDuration parsedDuration |
	targetDuration := Duration
		days: 0
		hours: 0
		minutes: 0
		seconds: 30.
	parsedDuration := Duration fromWLString: '30'.
	self assert: targetDuration equals: parsedDuration! !

!WLDurationExtensionTests methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:45'!
testEmptyStringParsing
	| targetDuration parsedDuration |
	targetDuration := nil.
	parsedDuration := Duration fromWLString: ''.
	self assert: targetDuration equals: parsedDuration! !

!WLDurationExtensionTests methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:32'!
testFullStringParsing
	| targetDuration parsedDuration |
	targetDuration := Duration
		days: 1
		hours: 2
		minutes: 20
		seconds: 30.
	parsedDuration := Duration fromWLString: '1d 2h 20m 30s'.
	self assert: targetDuration equals: parsedDuration! !

!WLDurationExtensionTests methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:32'!
testOnlyMinutesParsing
	| targetDuration parsedDuration |
	targetDuration := Duration
		days: 0
		hours: 0
		minutes: 20
		seconds: 0.
	parsedDuration := Duration fromWLString: '20m'.
	self assert: targetDuration equals: parsedDuration! !

!WLDurationExtensionTests methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/18/2016 23:32'!
testPartialStringParsing
	| targetDuration parsedDuration |
	targetDuration := Duration
		days: 1
		hours: 0
		minutes: 0
		seconds: 30.
	parsedDuration := Duration fromWLString: '1d 30s'.
	self assert: targetDuration equals: parsedDuration! !

TestCase subclass: #WLEditSessionsViewTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLEditSessionsViewTest methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:57'!
testGetDateOfWorkout
	| sessions exercise person group component |
	group := WLGroup named: 'Test Group'.
	exercise := WLLiftExercise newNamed: #TestLift.
	person := WLPerson named: 'Test Person' inGroup: group.
	sessions := {(person getSessionForExercise: exercise onDate: Date today)}.
	component := WLEditSessionsView new sessions: sessions.
	self assert: component getDateOfWorkout equals: Date today! !

!WLEditSessionsViewTest methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:40'!
testGetPeopleInWorkout
	| sessions exercise person group component |
	group := WLGroup named: 'Test Group'.
	exercise := WLLiftExercise newNamed: #TestLift.
	person := WLPerson named: 'Test Person' inGroup: group.
	sessions := {(person getSessionForExercise: exercise onDate: Date today)}.
	component := WLEditSessionsView new sessions: sessions.
	self assert: component getPeopleInWorkout size equals: 1.
	self assert: (component getPeopleInWorkout allSatisfy: [ :each | each = person ])! !

!WLEditSessionsViewTest methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:42'!
testGetPeopleInWorkout2
	| sessions exercise person otherPerson group component |
	group := WLGroup named: 'Test Group'.
	exercise := WLLiftExercise newNamed: #TestLift.
	person := WLPerson named: 'Test Person' inGroup: group.
	otherPerson := WLPerson named: 'Test Other Person' inGroup: group.
	sessions := {(person getSessionForExercise: exercise onDate: Date today).
	(otherPerson getSessionForExercise: exercise onDate: Date today)}.
	component := WLEditSessionsView new sessions: sessions.
	self assert: component getPeopleInWorkout size equals: 2.
	self assert: (component getPeopleInWorkout includes: person).
	self assert: (component getPeopleInWorkout includes: otherPerson)! !

TestCase subclass: #WLExerciseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLExerciseTest methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:28'!
testDisplayStrings
	| strings |
	strings := WLExercise allSubclasses collect: [ :each | each displayString ].
	self assertCollection: strings equals: (OrderedCollection with: #Lift with: #Timed with: #Run)! !

!WLExerciseTest methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:19'!
testDisplayStringsAsDictionary
	| strings |
	strings := Dictionary new.
	WLExercise subclasses collect: [ :each | each -> each displayString ] thenDo: [ :each | strings add: each ].
	self assert: (strings at: WLLiftExercise) equals: WLLiftExercise displayString.
	self assert: (strings at: WLTimedExercise) equals: WLTimedExercise displayString! !

TestCase subclass: #WLGroupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLGroupTest methodsFor: 'tests' stamp: 'MarkNelson 5/17/2016 21:21'!
testGetSessionsByPersonFor
	| group person session targetSessions exercise|
	group := WLGroup named: 'Test Group'.
	person := WLPerson named: 'Test Person'.
	exercise := WLLiftExercise newNamed: #Deadlift.
	session := WLSession new
		exercise: exercise;
		yourself.
		session addSet: (exercise createNewSet weight: 135; reps:5; yourself).
	person addSession: session.
	group addPerson: person.
	targetSessions := group getSessionsByPersonFor: #Deadlift.
	self assert: targetSessions class equals: Dictionary.
	self assert: (targetSessions at: person) first equals: session! !

!WLGroupTest methodsFor: 'tests' stamp: 'MarkNelson 5/22/2016 22:45'!
testRemoveEmptySessions
	| group person session |
	group := WLGroup named: 'Test Group'.
	person := WLPerson named: 'Test Person'.
	session := WLSession new.
	group addPerson: person.
	person addSession: session.
	self assert: (person hasSession: session) equals: true.
	self assert: (group people includes: person) equals: true.
	group removeEmptySessions.
	self assert: (person hasSession: session) equals: false.
	self assert: session person equals: nil! !

TestCase subclass: #WLPersonTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLPersonTest methodsFor: 'tests' stamp: 'MarkNelson 5/22/2016 22:46'!
testGetSessionsFor
	| person targetSessions exercise|
	person := WLPerson named: 'Foo bar'.
	exercise := WLExercise newNamed: #Deadlift.
	person addSession: (WLSession withExercise: exercise forPerson: person onDate: Date today).
	targetSessions := person getAllSessionsForExercise: #Deadlift.
	self assert: targetSessions class equals: OrderedCollection.
	self assert: targetSessions size equals: 1! !

!WLPersonTest methodsFor: 'tests' stamp: 'MarkNelson 5/22/2016 22:46'!
testGetSessionsForMissingLift
	| person targetSessions exercise|
	person := WLPerson named: 'Foo bar'.
	
	exercise := WLExercise newNamed: #Deadlift.
	person addSession: (WLSession withExercise: exercise forPerson: person onDate: Date today).
	targetSessions := person getAllSessionsForExercise: #Squat.
	self assert: targetSessions class equals: OrderedCollection.
	self assert: targetSessions size equals: 0! !

!WLPersonTest methodsFor: 'tests' stamp: 'MarkNelson 5/17/2016 21:11'!
testRemoveEmptySessions
	| person session exercise|
	
	exercise := WLExercise newNamed: #Deadlift.
	person := WLPerson named: 'Test User'.
	session := WLSession withExercise: exercise forPerson: person onDate: Date today.
	person addSession: session.
	self assert: (person sessions includes: session) equals: true.
	person removeEmptySessions.
	self assert: (person sessions includes: session) equals: false.
	self assert: session person equals: nil! !

TestCase subclass: #WLSessionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLSessionTest methodsFor: 'tests' stamp: 'MarkNelson 5/17/2016 21:21'!
testIsEmpty
	| session exercise|
	exercise := WLLiftExercise newNamed: #Deadlift.
	session := WLSession new.
	self assert: session isEmpty equals: true.
	session person: WLPerson new.
	session exercise: exercise.
	session date: Date today.
	self assert: session isEmpty equals: true.
	session sets: OrderedCollection new.
	self assert: session isEmpty equals: true.
	session addSet: exercise createNewSet.
	self assert: session isEmpty equals: true! !

!WLSessionTest methodsFor: 'tests' stamp: 'MarkNelson 5/8/2016 21:22'!
testIsNotEmpty
	| session |
	session := WLSession new.
	session sets: OrderedCollection new.
	self assert: session isEmpty equals: true.
	session addSet: WLSet new.
	self assert: session isEmpty equals: true.
	session addSet: (WLSet withPounds: 124 byReps: 5).
	self assert: session isEmpty equals: false! !

!WLSessionTest methodsFor: 'tests' stamp: 'MarkNelson 5/19/2016 23:48'!
testMaxWeight
	| session exercise|
	session := WLSession new.
	exercise := WLLiftExercise new.
	session exercise: exercise.
	session addSet: (exercise newSetWithPounds: 135 andReps: 5).
	session addSet: (exercise newSetWithPounds: 222 andReps: 1).
	self assert: session maxExerciseValue equals: 222! !

TestCase subclass: #WLSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLSetTest methodsFor: 'tests' stamp: 'MarkNelson 5/17/2016 21:21'!
testIsEmpty
	| set |
	set := WLLiftSet new.
	self assert: set isEmpty equals: true.
	set exercise: #Deadlift.
	self assert: set isEmpty equals: true.
	set weight: 5.
	self assert: set isEmpty equals: false.
	set weight: ''.
	set reps: ''.
	self assert: set isEmpty equals: true! !

!WLSetTest methodsFor: 'tests' stamp: 'MarkNelson 5/8/2016 21:15'!
testIsNotEmpty
	| set |
	set := WLSet withPounds: 135 byReps: 5.
	self assert: set isEmpty equals: false.
	set reps: 0.
	self assert: set isEmpty equals: false.
	set weight: 0.
	self assert: set isEmpty equals: true! !

TestCase subclass: #WLTimedSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Test'!

!WLTimedSetTest methodsFor: 'tests' stamp: 'MarkNelson 5/19/2016 23:31'!
testAddingSecondsSetIsNotEmpty
	| set |
	set := WLTimedSet new seconds: 10.
	self assert: set isEmpty equals: false! !

!WLTimedSetTest methodsFor: 'tests' stamp: 'MarkNelson 5/19/2016 23:30'!
testIsEmpty
	| set |
	set := WLTimedSet new.
	self assert: set isEmpty equals: true! !

!WAHtmlCanvas methodsFor: '*WeightLiftLog-View' stamp: 'MarkNelson 5/14/2016 08:55'!
tbsButtonLink
	^ self anchor class: 'btn'! !

!WAHtmlCanvas methodsFor: '*WeightLiftLog-View' stamp: 'MarkNelson 5/14/2016 08:55'!
tbsButtonLink: aBlockOrString
	^ self anchor
		class: 'btn';
		with: aBlockOrString! !

Object subclass: #WLExercise
	instanceVariableNames: 'exerciseName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

WLExercise subclass: #WLBodyWeightExercise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLBodyWeightExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:08'!
displayString
	^ 'Body Weight Reps'! !

!WLBodyWeightExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:43'!
createNewSet
	^ WLBodyWeightSet new exercise: self! !

!WLBodyWeightExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:44'!
minMaxProperty
	^ #reps! !

!WLExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:03'!
displayString
	self shouldBeImplemented.! !

!WLExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:10'!
newNamed: aSymbolOrString
	^ self new
		exerciseName: aSymbolOrString;
		yourself! !

!WLExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 14:58'!
createNewSet
self subclassResponsibility ! !

!WLExercise methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 14:40'!
exerciseName
	^ exerciseName! !

!WLExercise methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 14:40'!
exerciseName: anObject
	exerciseName := anObject! !

!WLExercise methodsFor: 'testing' stamp: 'MarkNelson 7/17/2016 15:12'!
isNamed: aString
	^ exerciseName = aString! !

!WLExercise methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:36'!
minMaxProperty
	"Property to use when displaying the min max values for a session"

	self subclassResponsibility! !

!WLExercise methodsFor: 'accessing' stamp: 'MarkNelson 10/13/2016 18:06'!
name
	^ self exerciseName! !

!WLExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:00'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' (';
		nextPutAll: exerciseName;
		nextPutAll: ')'! !

WLExercise subclass: #WLLiftExercise
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLLiftExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:04'!
displayString
	^ #Lift! !

!WLLiftExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:43'!
createNewSet
	^ WLLiftSet new exercise: self! !

!WLLiftExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/19/2016 23:36'!
minMaxProperty
	^ #weight! !

!WLLiftExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/19/2016 23:47'!
newSetWithPounds: aNumber andReps: anotherNumber
	^ WLLiftSet withPounds: aNumber byReps: anotherNumber! !

WLExercise subclass: #WLTimedExercise
	instanceVariableNames: 'targetSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLTimedExercise commentStamp: 'MarkNelson 5/15/2016 14:54' prior: 0!
So what can we do to handle calisthenics? How do we want the input to look?
For dragon flag holds, we want to move up to a target time, and however many sets to take us to get there we want to log that.
For normal dragon flags, how do we want to record that? Just counting reps? So WLBodyWeightExercise?
So to create a new exercise type, how do we do that? What makes sense? Can we present a choice list when creating an exercise type? So the WLSet needs to modify itself based on what type of exercise it is?


Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	seconds:		<Object>


    Implementation Points!

WLTimedExercise subclass: #WLRunExercise
	instanceVariableNames: 'distance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLRunExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:23'!
displayString
	^ #Run! !

!WLTimedExercise class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 23:04'!
displayString
	^ #Timed! !

!WLTimedExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/15/2016 14:59'!
createNewSet
^ WLTimedSet new exercise: self! !

!WLTimedExercise methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/19/2016 23:36'!
minMaxProperty
	^ #seconds! !

!WLTimedExercise methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:38'!
targetSeconds
	^ targetSeconds! !

!WLTimedExercise methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:38'!
targetSeconds: anObject
	targetSeconds := anObject! !

Object subclass: #WLLiftToBodyWeightTransform
	instanceVariableNames: 'sessions targetExercise targetSetType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Transformers'!

!WLLiftToBodyWeightTransform commentStamp: 'MarkNelson 7/19/2016 21:41' prior: 0!
My job is to transform a WLLiftExercise and associated data into a WLBodyWeightExercise.

Woo!! This is my first use of become:, and I think it worked out pretty well. No obvious bugs noticed in the inaugral transform.!

!WLLiftToBodyWeightTransform class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:40'!
turn: exerciseName into: aWLBodyWeightExercise withSetType: aWLSetClass forGroup: aWLGroup
	"WLLiftToBodyWeightTransform turn: 'Dragon Flag' into: (WLBodyWeightExercise newNamed:'Dragon Flag - Normal') withSetType: WLBodyWeightSet forGroup: (WLGroup findNamed: 'Avalon')."

	| instance |
	instance := self new.
	instance sessions: (aWLGroup getAllSessionsForExerciseNamed: exerciseName).
	instance targetExercise: aWLBodyWeightExercise.
	instance targetSetType: aWLSetClass.
	^ instance! !

!WLLiftToBodyWeightTransform methodsFor: 'private' stamp: 'MarkNelson 7/19/2016 21:22'!
createNewBodyWeightSetFrom: aWLLiftSet
	| newSet |
	newSet := targetSetType new reps: aWLLiftSet reps.
	^ newSet! !

!WLLiftToBodyWeightTransform methodsFor: 'transform-actions' stamp: 'MarkNelson 7/19/2016 21:37'!
performTransformation
	sessions do: [ :each | self transformSession: each ].
	sessions first exercise become: targetExercise! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
sessions
	^ sessions! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
sessions: anObject
	sessions := anObject! !

!WLLiftToBodyWeightTransform methodsFor: 'private' stamp: 'MarkNelson 7/19/2016 21:37'!
setExerciseFor: aWLSession
	aWLSession exercise become: targetExercise! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
targetExercise
	^ targetExercise! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
targetExercise: anObject
	targetExercise := anObject! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
targetSetType
	^ targetSetType! !

!WLLiftToBodyWeightTransform methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 21:18'!
targetSetType: anObject
	targetSetType := anObject! !

!WLLiftToBodyWeightTransform methodsFor: 'private' stamp: 'MarkNelson 7/19/2016 21:37'!
transformSession: aWLSession
	self transformSetsFor: aWLSession! !

!WLLiftToBodyWeightTransform methodsFor: 'private' stamp: 'MarkNelson 7/19/2016 21:36'!
transformSetsFor: aWLSession
	| liftSets |
	liftSets := aWLSession sets.
	liftSets
		do: [ :each | 
			| bodyWeightSet |
			bodyWeightSet := self createNewBodyWeightSetFrom: each.
			each become: bodyWeightSet ]! !

Object subclass: #WLPerson
	instanceVariableNames: 'name group sessions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLPerson class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:42'!
inGroup: aWLGroup
	^ self named: nil inGroup: aWLGroup! !

!WLPerson class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:15'!
named: aString
^ self new name: aString; yourself.! !

!WLPerson class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 22:22'!
named: aString inGroup: aWLGroup
	| person |
	person := self new
		name: aString;
		group: aWLGroup;
		yourself.
	aWLGroup addPerson: person.
	^ person! !

!WLPerson methodsFor: 'adding' stamp: 'MarkNelson 5/8/2016 21:28'!
addSession: aWLSession
	aWLSession person: self.
	self sessions add: aWLSession! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 21:45'!
getAllSessions
^ sessions! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 7/17/2016 10:37'!
getAllSessionsForExercise: aLiftName
	^ self sessions select: [ :session | session exerciseName = aLiftName ]! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:46'!
getAllSessionsOnDate: aDate
	^ self sessions select: [ :each | each date = aDate ]! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/19/2016 23:42'!
getMaxForLift: aString beforeDate: aDate
	| reverseOrderByDate previousSession |
	reverseOrderByDate := self sessions sorted: [ :a :b | b date < a date ].
	previousSession := reverseOrderByDate detect: [ :e | e date < aDate and: [ e exerciseName = aString ] ] ifNone: [ nil ].
	^ previousSession ifNotNil: [ previousSession maxExerciseValue ]! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/19/2016 23:41'!
getMinForLift: aString beforeDate: aDate 
|reverseOrderByDate previousSession|
reverseOrderByDate := self sessions sorted:[:a :b |  b date < a date].
previousSession := reverseOrderByDate detect: [ :e | e date < aDate and: [ e exerciseName = aString ]] ifNone:[nil].
^ previousSession ifNotNil: [ previousSession minExerciseValue ]
! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:36'!
getSessionForExercise: aWLExercise onDate: aDate
	^ self sessions
		detect: [ :each | each exerciseName = aWLExercise exerciseName and: [ each date = aDate ] ]
		ifNone: [ 
			| newSession |
			newSession := WLSession withExercise: aWLExercise forPerson: self onDate: aDate.
			self addSession: newSession.
			newSession ]! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/22/2016 22:46'!
getSessionForLiftName: aString beforeDate: aDate
	| reverseOrderByDate previousSession |
	reverseOrderByDate := (self getAllSessionsForExercise: aString) sorted: [ :a :b | b date < a date ].
	previousSession := reverseOrderByDate detect: [ :e | e date < aDate ] ifNone: [ nil ].
	^ previousSession! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:17'!
group
	^ group! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 22:17'!
group: anObject
	group := anObject! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/17/2016 10:37'!
hasSession: aWLSession
	^ self sessions includes: aWLSession! !

!WLPerson methodsFor: 'initialization' stamp: 'MarkNelson 7/17/2016 10:37'!
initialize
	super initialize.
	group := nil.
	name := nil.
	sessions := nil! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 21:55'!
name
^ name! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 21:55'!
name: anObject
	name := anObject! !

!WLPerson methodsFor: 'printing' stamp: 'MarkNelson 5/6/2016 07:15'!
printOn: aStream
	super printOn: aStream.
	self name
		ifNotNil: [ 
			aStream
				nextPutAll: ' - ';
				nextPutAll: self name ].
	self group
		ifNotNil: [ 
			aStream
				nextPutAll: ' (';
				nextPutAll: self group groupName;
				nextPutAll: ')' ]! !

!WLPerson methodsFor: 'removing' stamp: 'MarkNelson 7/17/2016 10:37'!
removeEmptySessions
	(self sessions select: [ :session | session isEmptyOrNil ]) do: [ :session | self removeSession: session ].
	self sessions do: [ :each | each removeEmptySets ]! !

!WLPerson methodsFor: 'removing' stamp: 'MarkNelson 7/17/2016 10:37'!
removeSession: aWLSession
self 	sessions remove: aWLSession.
	aWLSession person: nil! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 10:45'!
sessions
	^ sessions ifNil: [ sessions := OrderedCollection new ]! !

!WLPerson methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 10:44'!
sessions: anObject
	sessions := anObject! !

!WLPerson methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:14'!
sessionsByLiftName
	| dict |
	dict := Dictionary new.
	self sessions
		do: [ :session | 
			(dict
				at: session exerciseName
				ifAbsent: [ dict at: session exerciseName put: (SortedCollection sortBlock: [ :a :b | b date < a date ]) ]) add: session ].
	^ dict! !

Object subclass: #WLSession
	instanceVariableNames: 'date person sets exercise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLSession class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 21:54'!
forPerson: aWLPerson
^ self forPerson: aWLPerson onDate: Date today.! !

!WLSession class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 4/28/2016 21:54'!
forPerson: aWLPerson onDate: aDate
^ self new person: aWLPerson; date: aDate; yourself! !

!WLSession class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 21:21'!
withExercise: aWLExercise forPerson: aWLPerson onDate: aDate
	^ self new
		person: aWLPerson;
		date: aDate;
		exercise: aWLExercise;
		yourself! !

!WLSession methodsFor: 'adding' stamp: 'MarkNelson 5/17/2016 21:18'!
addSet: aWLSet
	sets add: aWLSet! !

!WLSession methodsFor: 'adding' stamp: 'MarkNelson 5/18/2016 01:08'!
createNewSet
	| set |
	set := exercise createNewSet.
	
	^ set! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 21:50'!
date
	^ date! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 21:50'!
date: anObject
	date := anObject! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:32'!
exercise
	^ exercise! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:32'!
exercise: aWLExercise
	exercise := aWLExercise! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:14'!
exerciseName
	^ exercise exerciseName! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/22/2016 23:30'!
getPreviousSession
	^ person getSessionForLiftName: exercise exerciseName beforeDate: date! !

!WLSession methodsFor: 'initialization' stamp: 'MarkNelson 5/1/2016 12:37'!
initialize
	super initialize.
	sets := OrderedCollection new! !

!WLSession methodsFor: 'testing' stamp: 'MarkNelson 5/8/2016 21:20'!
isEmpty
^ sets isEmptyOrNil or: [ sets allSatisfy: [ :set | set isEmpty ] ]! !

!WLSession methodsFor: 'testing' stamp: 'MarkNelson 5/8/2016 21:44'!
isEmptyOrNil
^ self isEmpty! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 8/21/2016 09:40'!
maxExerciseValue
	"Get the max value for this session. This could be weight, seconds or something else depending on what the exercise uses to track progress.
	I may want to consider adding a units class to make labeling these values on the page simpler/easier."

	^ sets isEmptyOrNil
		ifTrue: [ nil ]
		ifFalse: [ self maxSet perform: exercise minMaxProperty ]! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 8/21/2016 09:40'!
maxSet
	^ sets
		inject: sets anyOne
		into: [ :max :each | 
			(exercise minMaxProperty value: each) > (exercise minMaxProperty value: max)
				ifTrue: [ each ]
				ifFalse: [ max ] ]! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 8/21/2016 09:41'!
minExerciseValue
	"Get the min value for this session. This could be weight, seconds or something else depending on what the exercise uses to track progress"

	^ sets isEmptyOrNil
		ifTrue: [ nil ]
		ifFalse: [ self minSet perform: exercise minMaxProperty ]! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 8/21/2016 09:41'!
minSet
	^ sets
		inject: sets anyOne
		into: [ :min :each | 
			(exercise minMaxProperty value: each) < (exercise minMaxProperty value: min)
				ifTrue: [ each ]
				ifFalse: [ min ] ]! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 4/28/2016 21:50'!
person
	^ person! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/8/2016 21:27'!
person: aWLPerson
	person := aWLPerson! !

!WLSession methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:56'!
printOn: aStream
	super printOn: aStream.
	aStream
		nextPutAll: ' (';
		nextPutAll: self exerciseName;
		nextPutAll: ')'! !

!WLSession methodsFor: 'testing' stamp: 'MarkNelson 5/18/2016 01:16'!
removeEmptySets
	(sets select: [ :each | each isEmpty ]) do: [ :each | sets remove: each ]! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 10:51'!
sets
	^ sets! !

!WLSession methodsFor: 'accessing' stamp: 'MarkNelson 5/1/2016 10:51'!
sets: anObject
	sets := anObject! !

Object subclass: #WLSet
	instanceVariableNames: 'liftName exercise'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

WLSet subclass: #WLBodyWeightSet
	instanceVariableNames: 'reps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLBodyWeightSet methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:46'!
isEmpty
	^ (reps = nil or: [ reps = '' ]) or: [ reps = 0 ]! !

!WLBodyWeightSet methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/19/2016 20:46'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: Character space.
	reps printOn: aStream.
	aStream nextPutAll: ' reps'! !

!WLBodyWeightSet methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 20:45'!
reps
	^ reps! !

!WLBodyWeightSet methodsFor: 'accessing' stamp: 'MarkNelson 7/19/2016 20:57'!
reps: aStringOrNumber
	reps := [ aStringOrNumber asNumber ]
		on: Error
		do: [ nil ]! !

WLSet subclass: #WLLiftSet
	instanceVariableNames: 'weight reps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLLiftSet methodsFor: 'testing' stamp: 'MarkNelson 5/15/2016 22:54'!
isEmpty
	^ self isEmptyWeight and: [ self isEmptyReps ]! !

!WLLiftSet methodsFor: 'testing' stamp: 'MarkNelson 5/19/2016 23:31'!
isEmptyReps
	^ (reps = nil or: [ reps = '' ]) or: [ reps = 0 ]! !

!WLLiftSet methodsFor: 'testing' stamp: 'MarkNelson 5/15/2016 22:54'!
isEmptyWeight
	^ (weight = nil or: [ weight = '' ]) or: [ weight = 0 ]! !

!WLLiftSet methodsFor: 'accessing' stamp: 'MarkNelson 5/18/2016 01:00'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: Character space.
	weight printOn: aStream.
	aStream nextPutAll: ' x '.
	reps printOn: aStream! !

!WLLiftSet methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:32'!
reps
	^ reps! !

!WLLiftSet methodsFor: 'accessing' stamp: 'MarkNelson 5/20/2016 00:38'!
reps: aStringOrNumber
	reps := [ aStringOrNumber asNumber ]
		on: Error
		do: [ nil ]! !

!WLLiftSet methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 15:00'!
weight
	^ weight! !

!WLLiftSet methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:18'!
weight: aStringOrNumber
	[ weight := aStringOrNumber asNumber ]
		on: Error
		do: [ weight := nil ]! !

!WLSet class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/2/2016 22:21'!
ofType: aWLLiftType withPounds: pounds byReps: repCount
	^ self new
	liftName: aWLLiftType ;
		weight: pounds;
		reps: repCount;
		yourself! !

!WLSet class methodsFor: 'as yet unclassified' stamp: 'MarkNelson 5/17/2016 18:51'!
withPounds: pounds byReps: repCount
	^ WLLiftSet new
		weight: pounds;
		reps: repCount;
		yourself! !

!WLSet methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 15:00'!
exercise
	^ exercise! !

!WLSet methodsFor: 'accessing' stamp: 'MarkNelson 5/15/2016 15:00'!
exercise: anObject
	exercise := anObject! !

!WLSet methodsFor: 'accessing' stamp: 'MarkNelson 5/17/2016 21:14'!
exerciseName
	^ liftName! !

!WLSet methodsFor: 'testing' stamp: 'MarkNelson 5/19/2016 23:32'!
isEmpty
	"WLSet should not be used directly, so returning true here is the easiest to get it removed if it is used by accident."

	^ true! !

WLSet subclass: #WLTimedSet
	instanceVariableNames: 'seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-Core'!

!WLTimedSet class methodsFor: 'migrations' stamp: 'MarkNelson 7/19/2016 18:12'!
updateExistingToUseDurations
	<migrateFrom: 01 to: 02>
	self allInstances select: [ :each | each seconds isNumber ] thenDo: [ :each | each seconds: each seconds ]! !

!WLTimedSet methodsFor: 'testing' stamp: 'MarkNelson 5/19/2016 23:33'!
isEmpty
	^ self isEmptyTime ! !

!WLTimedSet methodsFor: 'testing' stamp: 'MarkNelson 5/15/2016 22:56'!
isEmptyTime
	^ (seconds = nil or: [ seconds = '' ]) or: [ seconds = 0 ]! !

!WLTimedSet methodsFor: 'accessing' stamp: 'MarkNelson 5/19/2016 23:27'!
seconds
	^ seconds! !

!WLTimedSet methodsFor: 'accessing' stamp: 'MarkNelson 7/18/2016 23:44'!
seconds: aStringOrNumber
	seconds := [ aStringOrNumber asWLDuration ]
		on: Error
		do: [ nil ]! !

!Duration class methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/18/2016 23:46'!
fromWLString: aString
	"Formatted roughly as '1d 3h 20m 30s'"

	| days hours minutes seconds tokenOrder tokens |
	aString isEmptyOrNil
		ifTrue: [ ^ nil ].
	days := 0.
	hours := 0.
	minutes := 0.
	seconds := 0.
	tokenOrder := #($d $h $m $s).
	tokens := aString findTokens: tokenOrder keep: tokenOrder.
	tokens size = 1
		ifTrue: [ ^ Duration seconds: tokens first asInteger ].
	tokens
		pairsCollect: [ :num :token | 
			token = 'd'
				ifTrue: [ days := num asInteger ].
			token = 'h'
				ifTrue: [ hours := num asInteger ].
			token = 'm'
				ifTrue: [ minutes := num asInteger ].
			token = 's'
				ifTrue: [ seconds := num asInteger ] ].
	^ self
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds! !

!Duration methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/19/2016 07:10'!
asWLDuration
	^ self! !

!Duration methodsFor: '*WeightLiftLog' stamp: 'MarkNelson 7/18/2016 23:43'!
asWLDurationString
	| outputWritten count |
	outputWritten := false.
	^ String
		streamContents: [ :out | 
			#(#(#days 'd') #(#hours 'h') #(#minutes 'm') #(#seconds 's'))
				do: [ :each | 
					count := self perform: each first.
					count > 0
						ifTrue: [ 
							outputWritten
								ifTrue: [ out space ].
							count printWithCommasOn: out.
							out
								space;
								<< each second.
							outputWritten := true ] ].
			outputWritten
				ifFalse: [ out << '' ] ]! !

WASession subclass: #WLSeasideSession
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WeightLiftLog-View'!

!WLSeasideSession methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:39'!
group
	^ group! !

!WLSeasideSession methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:39'!
group: aWLGroup
	group := aWLGroup! !

!WLSeasideSession methodsFor: 'as yet unclassified' stamp: 'MarkNelson 7/3/2016 00:39'!
isAuthenticated
	^ group isNotNil! !
WLAddNewPersonView initialize!
WLBackupsHandler initialize!
WLApplicationRootComponent initialize!
